package com.adventurer_engine.client.model;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import atv;
import bjo;
import com.adventurer_engine.client.model.ItemModelBaked;
import com.adventurer_engine.common.items.ItemLoader;
import com.adventurer_engine.common.items.blank.Full3DItem;
import com.google.gson.internal.StringMap;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import net.minecraftforge.client.IItemRenderer;
import org.lwjgl.opengl.GL11;
import ss;
import yc;
import ye;

@SideOnly(Side.CLIENT)
public class ItemModelLoader implements IItemRenderer {
  public static final StringMap<ItemModelBaked> modelMap = new StringMap();
  
  public static float smoothing;
  
  public static void loadModel() {
    for (yc i : ItemLoader.item) {
      if (!(i instanceof Full3DItem) || !((Full3DItem)i).hasModel())
        continue; 
      String modelName = ((Full3DItem)i).getModelName();
      ItemModelBaked bakedModel = new ItemModelBaked(new bjo("adventurer_engine:model/" + modelName + ".json"), new bjo("adventurer_engine:textures/model/" + modelName + ".png"));
      modelMap.put(((Full3DItem)i).getModelName(), bakedModel);
    } 
  }
  
  public boolean handleRenderType(ye item, IItemRenderer.ItemRenderType type) {
    return (type != IItemRenderer.ItemRenderType.INVENTORY);
  }
  
  public boolean shouldUseRenderHelper(IItemRenderer.ItemRenderType type, ye item, IItemRenderer.ItemRendererHelper helper) {
    return false;
  }
  
  public void renderItem(IItemRenderer.ItemRenderType type, ye item, Object... data) {
    float vx, vy, vz;
    ss entity;
    if (!(item.b() instanceof Full3DItem))
      return; 
    ItemModelBaked model = (ItemModelBaked)modelMap.get(((Full3DItem)item.b()).getModelName());
    if (model == null)
      return; 
    float f = 0.0625F;
    (atv.w()).N.a(model.texture);
    float[] entityData = { -0.5F, 0.0F, -0.5F, 1.0F, 1.0F, 1.0F };
    float[] equippedData = { 0.0F, 195.5F, 0.0F, -0.85F, 0.1F, -1.0F, 1.0F, 1.0F, 1.0F };
    float[] firstPersonData = { -25.0F, -112.0F, -23.0F, -0.8F, 0.0F, -1.2F, 1.0F, 1.0F, 1.0F };
    GL11.glPushMatrix();
    switch (null.$SwitchMap$net$minecraftforge$client$IItemRenderer$ItemRenderType[type.ordinal()]) {
      case 1:
        entity = (ss)data[1];
        GL11.glRotatef((entity.a + ((entity.a == 0) ? 0.0F : smoothing)) * 20.0F, 0.0F, 1.0F, 0.0F);
        GL11.glTranslatef(entityData[0], entityData[1], entityData[2]);
        GL11.glScalef(entityData[3], entityData[4], entityData[5]);
        break;
      case 2:
        GL11.glRotatef(-equippedData[0], 1.0F, 0.0F, 0.0F);
        vx = 0.0F;
        vy = -cos(equippedData[0]);
        vz = -sin(equippedData[0]);
        GL11.glRotatef(-equippedData[1], vx, vy, vz);
        vx = -cos(equippedData[0]) * sin(equippedData[1]);
        vy = -sin(equippedData[0]);
        vz = cos(equippedData[0]) * cos(equippedData[1]);
        GL11.glRotatef(-equippedData[2], vx, vy, vz);
        GL11.glTranslatef(equippedData[3], equippedData[4], equippedData[5]);
        GL11.glScalef(equippedData[6], equippedData[7], equippedData[8]);
        break;
      case 3:
        GL11.glRotatef(-firstPersonData[0], 1.0F, 0.0F, 0.0F);
        vx = 0.0F;
        vy = -cos(firstPersonData[0]);
        vz = -sin(firstPersonData[0]);
        GL11.glRotatef(-firstPersonData[1], vx, vy, vz);
        vx = -cos(firstPersonData[0]) * sin(firstPersonData[1]);
        vy = -sin(firstPersonData[0]);
        vz = cos(firstPersonData[0]) * cos(firstPersonData[1]);
        GL11.glRotatef(-firstPersonData[2], vx, vy, vz);
        GL11.glTranslatef(firstPersonData[3], firstPersonData[4], firstPersonData[5]);
        GL11.glScalef(firstPersonData[6], firstPersonData[7], firstPersonData[8]);
        break;
    } 
    if (type != IItemRenderer.ItemRenderType.INVENTORY) {
      GL11.glPushMatrix();
      GL11.glScalef(model.modelScale, model.modelScale, model.modelScale);
      model.renderItem(f);
      GL11.glPopMatrix();
    } 
    GL11.glPopMatrix();
  }
  
  private static float sin(float a) {
    return (float)Math.sin((a / 180.0F) * Math.PI);
  }
  
  private static float cos(float a) {
    return (float)Math.cos((a / 180.0F) * Math.PI);
  }
}
